using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace WeaponMod
{
    public class WeaponMod
    {
        public static void Main()
        {

            //Firearms
            //AK-74
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("AK-47"),
                    NameOverride = "AK-74 WM",
                    NameToOrderByOverride = "AK-47 2",
                    DescriptionOverride = "It has less damage, but is lighter and has less recoil.",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("AK74View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AK74.png", 2f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
                        customCartridge.name = "5.45x39mm";
                        customCartridge.Damage *= 0.2f; 
                        customCartridge.StartSpeed *= 1f;
                        customCartridge.Recoil *= 0.3f;
                        firearm.Cartridge = customCartridge;

                    }
                }
            );

            //PPS-43
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("AK-47"),
                    NameOverride = "PPS-43 WM",
                    NameToOrderByOverride = "PPSH 2",
                    DescriptionOverride = "Not famous Soviet submachine gun",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("PPS-43View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("PPS-43.png", 1.9f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.4f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.4f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                         {
                         ModAPI.LoadSound("PPS.wav"),
                          };
                        Instance.FixColliders();
                    }
                }
            );

            //S&W.44Magnum
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Revolver"),
                    NameOverride = "S&W.44Magnum WM",
                    NameToOrderByOverride = "Revolver 2",
                    DescriptionOverride = "Very powerful revolver",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("S&W.44MagnumView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("S&W.44Magnum.png", 1.9f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("38 Special");
                        customCartridge.name = ".40";
                        customCartridge.Damage *= 3.5f; 
                        customCartridge.StartSpeed *= 0.5f;
                        customCartridge.ImpactForce *= 10f;
                        firearm.Cartridge = customCartridge;
                    }
                }
            );

            //STEN
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                    NameOverride = "STEN WM",
                    NameToOrderByOverride = "Submachine Gun 2",
                    DescriptionOverride = "Strange submachine gun",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("STENView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("STEN.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            //LugerP08
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Luger P08 WM",
                    NameToOrderByOverride = "Glock 17 2",
                    DescriptionOverride = "This is Luger! Everyone knows about him...(Offer dankelol670)",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("LugerP08View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("LugerP08.png", 2.1f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                         {
                         ModAPI.LoadSound("aa2.wav"),
                          };
                        Instance.FixColliders();
                    }
                }
            );

            //Remington870
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                    NameOverride = "Remington 870 WM",
                    NameToOrderByOverride = "Shotgun 2",
                    DescriptionOverride = "I love shotguns (Offer akk139801.THC)",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Remington870View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Remington870.png", 2.1f);
                        Instance.FixColliders();
                    }
                }
            );

            //P90
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Vector"),
                    NameOverride = "P90 WM",
                    NameToOrderByOverride = "Vector 2",
                    DescriptionOverride = "Futuristic submachine gun (Offer L1TB0T)",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("P90View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("P90.png", 1.9f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                        customCartridge.name = "5,7 × 28mm";
                        customCartridge.Damage *= 1f; 
                        customCartridge.StartSpeed *= 1.7f;
                        firearm.Cartridge = customCartridge;
                        Instance.FixColliders();
                    }
                }
            );

            //AWP
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "AWP WM",
                    NameToOrderByOverride = "Sniper Rifle 2",
                    DescriptionOverride = "one shot - one kill (Offer 希望_LacosteTN)",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("AWPView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AWP.png", 1.9f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "50 BMG AWP";
                        customCartridge.Damage *= 1000f; 
                        customCartridge.StartSpeed *= 100f;
                        customCartridge.ImpactForce *= 3f;
                        firearm.Cartridge = customCartridge;
                        Instance.FixColliders();
                    }
                }
            );

            //HK XM8
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Vector"),
                    NameOverride = "HK XM8 WM",
                    NameToOrderByOverride = "Vector 3",
                    DescriptionOverride = "Futuristic submachine gun №2 (Offer Miguel Freitas)",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("HKXM8View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HKXM8.png", 1.8f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                        customCartridge.name = "5,7 × 28mm";
                        customCartridge.Damage *= 0.9f; 
                        customCartridge.StartSpeed *= 1.3f;
                        firearm.Cartridge = customCartridge;
                        Instance.FixColliders();
                    }
                }
            );

            //MG42
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Light Machine Gun"),
                    NameOverride = "MG42 WM",
                    NameToOrderByOverride = "Light Machine Gun 2",
                    DescriptionOverride = "Hitler's Circular Saw (Offer matump98)",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("MG42View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MG42.png", 1.8f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                         {
                         ModAPI.LoadSound("aa1.wav"),
                          };
                        Instance.FixColliders();
                    }
                }
            );

            //SCAR-L
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "SCAR-L WM",
                    NameToOrderByOverride = "Assault Rifle 2",
                    DescriptionOverride = "Good assault rifle (Offer KEkek)",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("SCAR-LView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SCAR-L.png", 2f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                        firearm.Cartridge = customCartridge;
                        Instance.FixColliders();

                    }
                }
            );
            
            //SVT-40
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "SVT-40 WM",
                    NameToOrderByOverride = "M1 Garand 2",
                    DescriptionOverride = "Popular in the USSR rifle 2WW (someradno1)",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("SVT-40View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SVT-40.png", 2.1f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("7.62x51mm");
                        firearm.Cartridge = customCartridge;
                        Instance.FixColliders();
                    }
                }
            );

            //Uzi
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                    NameOverride = "Uzi WM",
                    NameToOrderByOverride = "Submachine Gun 3",
                    DescriptionOverride = "Strange submachine gun",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("UziView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Uzi2.png", 2f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9×19mm Parabellum";
                        customCartridge.Damage *= 0.6f; 
                        customCartridge.ImpactForce *= 0.6f;
                        firearm.Cartridge = customCartridge;
                        Instance.FixColliders();
                    }
                }
            );

            //Potato gun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Potato gun WM",
                    DescriptionOverride = "Potato gun",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("PotatoGunView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("PotatoGun.png", 2f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 10;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Potato WM");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 5f;
                        Instance.FixColliders();
                    }
                }
            );

            //Melee
            //Karambit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Karambit WM",
                    NameToOrderByOverride = "Knife 2",
                    DescriptionOverride = "Karambit with a terrible texture (Offer TorSkyy)",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("KarambitView.png", 2f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Karambit.png", 2f);
                    }
                }
            );
            //Bayonet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Bayonet WM",
                    NameToOrderByOverride = "Knife 3",
                    DescriptionOverride = "Bayonet",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("BayonetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Bayonet.png", 3f);
                        Instance.FixColliders();
                    }
                }
            );
            //???
            //potato
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"), 
                    NameOverride = "Potato WM",
                    DescriptionOverride = "It is a Potato", 
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("PotatoView.png"),
                    AfterSpawn = (Instance) => 
                    {
                    	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Potato1.png", 3f);
                    	Instance.FixColliders();
                    }
                }
            );
        }
    }
}